| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | List of all members
nkGraphics::ContentLoader Class Referencefinal

Utility class that allows to load content through their declaration files. More...

## Public Member Functions
| ContentLoader (System *system) noexcept
nkExport::ExporterLoadResult | inputData (nkMemory::StringView filePath)
nkMemory::String | inputDataStr (nkMemory::StringView filePath)
nkExport::ExporterLoadResult | inputDataSources (nkMemory::StringView sources)
bool | outputData (nkMemory::StringView content, nkMemory::StringView path)
bool | saveTreeDeclaration (nkExport::Node *tree, nkMemory::StringView pathFromData)
bool | saveObjectDeclaration (nkExport::Exportable *object, nkMemory::StringView pathFromData)
ContentLoadResultTexture | loadTextureDeclaration (nkMemory::StringView pathFromData, bool loadResource=true)
ContentLoadResultTexture | processTextureSources (nkMemory::StringView sources, bool loadResource=true)
ContentLoadResultTexture | processTextureTree (nkExport::Node *tree, bool loadResource=true)
ContentLoadResultSampler | loadSamplerDeclaration (nkMemory::StringView pathFromData, bool loadResource=true)
ContentLoadResultSampler | processSamplerSources (nkMemory::StringView sources, bool loadResource=true)
ContentLoadResultSampler | processSamplerTree (nkExport::Node *tree, bool loadResource=true)
ContentLoadResultProgram | loadShaderProgramDeclaration (nkMemory::StringView pathFromData, bool loadResource=true)
ContentLoadResultProgram | processShaderProgramSources (nkMemory::StringView sources, bool loadResource=true)
ContentLoadResultProgram | processShaderProgramTree (nkExport::Node *tree, bool loadResource=true)
ContentLoadResultShaderMemorySlot | loadShaderMemorySlotDeclaration (nkMemory::StringView pathFromData)
ContentLoadResultShaderMemorySlot | processShaderMemorySlotSources (nkMemory::StringView sources)
ContentLoadResultShaderMemorySlot | processShaderMemorySlotDeclarationTree (nkExport::Node *tree)
ContentLoadResultConstantBuffer | loadConstantBufferDeclaration (nkMemory::StringView pathFromData)
ContentLoadResultConstantBuffer | processConstantBufferSources (nkMemory::StringView sources)
ContentLoadResultConstantBuffer | processConstantBufferDeclarationTree (nkExport::Node *tree)
ContentLoadResultBuffer | loadBufferDeclaration (nkMemory::StringView pathFromData, bool loadResource=true)
ContentLoadResultBuffer | processBufferSources (nkMemory::StringView sources, bool loadResource=true)
ContentLoadResultBuffer | processBufferDeclarationTree (nkExport::Node *tree, bool loadResource=true)
ContentLoadResultShader | loadShaderDeclaration (nkMemory::StringView pathFromData, bool loadResource=true)
ContentLoadResultShader | processShaderDeclarationSources (nkMemory::StringView sources, bool loadResource=true)
ContentLoadResultShader | processShaderDeclarationTree (nkExport::Node *tree, bool loadResource=true)
ContentLoadResultPass | loadPassDeclaration (nkMemory::StringView pathFromData)
ContentLoadResultPass | processPassSources (nkMemory::StringView sources)
ContentLoadResultPass | processPassTree (nkExport::Node *tree)
ContentLoadResultCompositor | loadCompositorDeclaration (nkMemory::StringView pathFromData)
ContentLoadResultCompositor | processCompositorSources (nkMemory::StringView sources)
ContentLoadResultCompositor | processCompositorTree (nkExport::Node *tree)
ContentLoadResultMesh | loadMeshDeclaration (nkMemory::StringView pathFromData, bool loadResource=true)
ContentLoadResultMesh | processMeshSources (nkMemory::StringView sources, bool loadResource=true)
ContentLoadResultMesh | processMeshTree (nkExport::Node *tree, bool loadResource=true)
ContentLoadResultNode | loadNodeDeclaration (nkMemory::StringView pathFromData)
ContentLoadResultNode | processNodeSources (nkMemory::StringView sources)
ContentLoadResultNode | processNodeTree (nkExport::Node *tree)
ContentLoadResultBlendState | loadBlendStateDeclaration (nkMemory::StringView pathFromData, bool loadResource=true)
ContentLoadResultBlendState | processBlendStateSources (nkMemory::StringView sources, bool loadResource=true)
ContentLoadResultBlendState | processBlendStateTree (nkExport::Node *tree, bool loadResource=true)
ContentLoadResultDepthStencilState | loadDepthStencilStateDeclaration (nkMemory::StringView pathFromData, bool loadResource=true)
ContentLoadResultDepthStencilState | processDepthStencilStateSources (nkMemory::StringView sources, bool loadResource=true)
ContentLoadResultDepthStencilState | processDepthStencilStateTree (nkExport::Node *tree, bool loadResource=true)
ContentLoadResultRasterState | loadRasterStateDeclaration (nkMemory::StringView pathFromData, bool loadResource=true)
ContentLoadResultRasterState | processRasterStateSources (nkMemory::StringView sources, bool loadResource=true)
ContentLoadResultRasterState | processRasterStateTree (nkExport::Node *tree, bool loadResource=true)
ContentLoadResultCamera | loadCameraDeclaration (nkMemory::StringView pathFromData)
ContentLoadResultCamera | processCameraSources (nkMemory::StringView sources)
ContentLoadResultCamera | processCameraTree (nkExport::Node *tree)
ContentLoadResultRenderQueue | loadRenderQueueDeclaration (nkMemory::StringView pathFromData)
ContentLoadResultRenderQueue | processRenderQueueSources (nkMemory::StringView sources)
ContentLoadResultRenderQueue | processRenderQueueTree (nkExport::Node *tree)
ContentLoadResultCompositorNode | appendCompositorNodeFromFile (nkMemory::StringView pathFromData, Compositor *parent)
ContentLoadResultCompositorNode | appendCompositorNodeFromSources (nkMemory::StringView sources, Compositor *parent)
ContentLoadResultCompositorNode | appendCompositorNodeFromTree (nkExport::Node *tree, Compositor *parent)

## Detailed Description

Utility class that allows to load content through their declaration files.

## Constructor & Destructor Documentation

## ◆ ContentLoader()

nkGraphics::ContentLoader::ContentLoader | ( | System * | system | ) |
| noexcept

Constructor.

Parameters

  system | The system the resource should live in.

## Member Function Documentation

## ◆ inputData()

nkExport::ExporterLoadResult nkGraphics::ContentLoader::inputData | ( | nkMemory::StringView | filePath | ) |

Inputs data from a file and returns associated tree, if parsing can occur. It will use Json parsing.

Parameters

  filePath | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.

Returns
  The result after loading designated file.

## ◆ inputDataStr()

nkMemory::String nkGraphics::ContentLoader::inputDataStr | ( | nkMemory::StringView | filePath | ) |

Inputs data from a file and only get the sources.

Parameters

  filePath | The file to find.

Returns
  The result after loading designated memory chunk.

## ◆ inputDataSources()

nkExport::ExporterLoadResult nkGraphics::ContentLoader::inputDataSources | ( | nkMemory::StringView | sources | ) |

Inputs data from memory and returns associated tree, if parsing can occur. It will use Json parsing.

Parameters

  sources | The sources to parse.

Returns
  The result after loading designated memory chunk.

## ◆ outputData()

bool nkGraphics::ContentLoader::outputData | ( | nkMemory::StringView | content,
|  | nkMemory::StringView | path
| ) |  |

Writes data to a file.

Parameters

  content | The content to write.
  path | The path, relative to working directory, to output the file to. See nkResources::ResourceManager for path naming convention.

Returns
  If the data could succesfully be output (true) or not (false).

## ◆ saveTreeDeclaration()

bool nkGraphics::ContentLoader::saveTreeDeclaration | ( | nkExport::Node * | tree,
|  | nkMemory::StringView | pathFromData
| ) |  |

Saves an aready exported tree into a file.

Parameters

  tree | The tree to export.
  pathFromData | The path, relative to working directory, to output the file to. See nkResources::ResourceManager for path naming convention.

Returns
  If the data could succesfully be output (true) or not (false).

## ◆ saveObjectDeclaration()

bool nkGraphics::ContentLoader::saveObjectDeclaration | ( | nkExport::Exportable * | object,
|  | nkMemory::StringView | pathFromData
| ) |  |

Saves an exportable into a file.

Parameters

  object | The object to serialize and export.
  pathFromData | The path, relative to working directory, to output the file to. See nkResources::ResourceManager for path naming convention.

Returns
  If the data could succesfully be output (true) or not (false).

## ◆ loadTextureDeclaration()

ContentLoadResultTexture nkGraphics::ContentLoader::loadTextureDeclaration | ( | nkMemory::StringView | pathFromData,
|  | bool | loadResource = `true`
| ) |  |

Loads a texture declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processTextureSources()

ContentLoadResultTexture nkGraphics::ContentLoader::processTextureSources | ( | nkMemory::StringView | sources,
|  | bool | loadResource = `true`
| ) |  |

Loads a texture declaration, from memory.

Parameters

  sources | The memory chunk to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processTextureTree()

ContentLoadResultTexture nkGraphics::ContentLoader::processTextureTree | ( | nkExport::Node * | tree,
|  | bool | loadResource = `true`
| ) |  |

Loads a texture declaration, from an existing tree.

Parameters

  tree | The tree to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ loadSamplerDeclaration()

ContentLoadResultSampler nkGraphics::ContentLoader::loadSamplerDeclaration | ( | nkMemory::StringView | pathFromData,
|  | bool | loadResource = `true`
| ) |  |

Loads a sampler declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processSamplerSources()

ContentLoadResultSampler nkGraphics::ContentLoader::processSamplerSources | ( | nkMemory::StringView | sources,
|  | bool | loadResource = `true`
| ) |  |

Loads a sampler declaration, from memory.

Parameters

  sources | The memory chunk to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processSamplerTree()

ContentLoadResultSampler nkGraphics::ContentLoader::processSamplerTree | ( | nkExport::Node * | tree,
|  | bool | loadResource = `true`
| ) |  |

Loads a sampler declaration, from an existing tree.

Parameters

  tree | The tree to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ loadShaderProgramDeclaration()

ContentLoadResultProgram nkGraphics::ContentLoader::loadShaderProgramDeclaration | ( | nkMemory::StringView | pathFromData,
|  | bool | loadResource = `true`
| ) |  |

Loads a shader program declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processShaderProgramSources()

ContentLoadResultProgram nkGraphics::ContentLoader::processShaderProgramSources | ( | nkMemory::StringView | sources,
|  | bool | loadResource = `true`
| ) |  |

Loads a shader program declaration, from memory.

Parameters

  sources | The memory chunk to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processShaderProgramTree()

ContentLoadResultProgram nkGraphics::ContentLoader::processShaderProgramTree | ( | nkExport::Node * | tree,
|  | bool | loadResource = `true`
| ) |  |

Loads a shader program declaration, from an existing tree.

Parameters

  tree | The tree to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ loadShaderMemorySlotDeclaration()

ContentLoadResultShaderMemorySlot nkGraphics::ContentLoader::loadShaderMemorySlotDeclaration | ( | nkMemory::StringView | pathFromData | ) |

Loads a memory slot declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.

Returns
  The load result.

## ◆ processShaderMemorySlotSources()

ContentLoadResultShaderMemorySlot nkGraphics::ContentLoader::processShaderMemorySlotSources | ( | nkMemory::StringView | sources | ) |

Loads a memory slot declaration, from memory.

Parameters

  sources | The memory chunk to interpret.

Returns
  The load result.

## ◆ processShaderMemorySlotDeclarationTree()

ContentLoadResultShaderMemorySlot nkGraphics::ContentLoader::processShaderMemorySlotDeclarationTree | ( | nkExport::Node * | tree | ) |

Loads a memory slot declaration, from an existing tree.

Parameters

  tree | The tree to interpret.

Returns
  The load result.

## ◆ loadConstantBufferDeclaration()

ContentLoadResultConstantBuffer nkGraphics::ContentLoader::loadConstantBufferDeclaration | ( | nkMemory::StringView | pathFromData | ) |

Loads a constant buffer declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.

Returns
  The load result.

## ◆ processConstantBufferSources()

ContentLoadResultConstantBuffer nkGraphics::ContentLoader::processConstantBufferSources | ( | nkMemory::StringView | sources | ) |

Loads a constant buffer declaration, from memory.

Parameters

  sources | The memory chunk to interpret.

Returns
  The load result.

## ◆ processConstantBufferDeclarationTree()

ContentLoadResultConstantBuffer nkGraphics::ContentLoader::processConstantBufferDeclarationTree | ( | nkExport::Node * | tree | ) |

Loads a constant buffer declaration, from an existing tree.

Parameters

  tree | The tree to interpret.

Returns
  The load result.

## ◆ loadBufferDeclaration()

ContentLoadResultBuffer nkGraphics::ContentLoader::loadBufferDeclaration | ( | nkMemory::StringView | pathFromData,
|  | bool | loadResource = `true`
| ) |  |

Loads a buffer declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processBufferSources()

ContentLoadResultBuffer nkGraphics::ContentLoader::processBufferSources | ( | nkMemory::StringView | sources,
|  | bool | loadResource = `true`
| ) |  |

Loads a buffer declaration, from memory.

Parameters

  sources | The memory chunk to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processBufferDeclarationTree()

ContentLoadResultBuffer nkGraphics::ContentLoader::processBufferDeclarationTree | ( | nkExport::Node * | tree,
|  | bool | loadResource = `true`
| ) |  |

Loads a buffer declaration, from an existing tree.

Parameters

  tree | The tree to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ loadShaderDeclaration()

ContentLoadResultShader nkGraphics::ContentLoader::loadShaderDeclaration | ( | nkMemory::StringView | pathFromData,
|  | bool | loadResource = `true`
| ) |  |

Loads a shader declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processShaderDeclarationSources()

ContentLoadResultShader nkGraphics::ContentLoader::processShaderDeclarationSources | ( | nkMemory::StringView | sources,
|  | bool | loadResource = `true`
| ) |  |

Loads a shader declaration, from memory.

Parameters

  sources | The memory chunk to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processShaderDeclarationTree()

ContentLoadResultShader nkGraphics::ContentLoader::processShaderDeclarationTree | ( | nkExport::Node * | tree,
|  | bool | loadResource = `true`
| ) |  |

Loads a shader declaration, from an existing tree.

Parameters

  tree | The tree to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ loadPassDeclaration()

ContentLoadResultPass nkGraphics::ContentLoader::loadPassDeclaration | ( | nkMemory::StringView | pathFromData | ) |

Loads a pass declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.

Returns
  The load result.

## ◆ processPassSources()

ContentLoadResultPass nkGraphics::ContentLoader::processPassSources | ( | nkMemory::StringView | sources | ) |

Loads a pass declaration, from memory.

Parameters

  sources | The memory chunk to interpret.

Returns
  The load result.

## ◆ processPassTree()

ContentLoadResultPass nkGraphics::ContentLoader::processPassTree | ( | nkExport::Node * | tree | ) |

Loads a pass declaration, from an existing tree.

Parameters

  tree | The tree to interpret.

Returns
  The load result.

## ◆ loadCompositorDeclaration()

ContentLoadResultCompositor nkGraphics::ContentLoader::loadCompositorDeclaration | ( | nkMemory::StringView | pathFromData | ) |

Loads a compositor declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.

Returns
  The load result.

## ◆ processCompositorSources()

ContentLoadResultCompositor nkGraphics::ContentLoader::processCompositorSources | ( | nkMemory::StringView | sources | ) |

Loads a compositor declaration, from memory.

Parameters

  sources | The memory chunk to interpret.

Returns
  The load result.

## ◆ processCompositorTree()

ContentLoadResultCompositor nkGraphics::ContentLoader::processCompositorTree | ( | nkExport::Node * | tree | ) |

Loads a compositor declaration, from an existing tree.

Parameters

  tree | The tree to interpret.

Returns
  The load result.

## ◆ loadMeshDeclaration()

ContentLoadResultMesh nkGraphics::ContentLoader::loadMeshDeclaration | ( | nkMemory::StringView | pathFromData,
|  | bool | loadResource = `true`
| ) |  |

Loads a mesh declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processMeshSources()

ContentLoadResultMesh nkGraphics::ContentLoader::processMeshSources | ( | nkMemory::StringView | sources,
|  | bool | loadResource = `true`
| ) |  |

Loads a mesh declaration, from memory.

Parameters

  sources | The memory chunk to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processMeshTree()

ContentLoadResultMesh nkGraphics::ContentLoader::processMeshTree | ( | nkExport::Node * | tree,
|  | bool | loadResource = `true`
| ) |  |

Loads a mesh declaration, from an existing tree.

Parameters

  tree | The tree to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ loadNodeDeclaration()

ContentLoadResultNode nkGraphics::ContentLoader::loadNodeDeclaration | ( | nkMemory::StringView | pathFromData | ) |

Loads a node declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.

Returns
  The load result.

## ◆ processNodeSources()

ContentLoadResultNode nkGraphics::ContentLoader::processNodeSources | ( | nkMemory::StringView | sources | ) |

Loads a node declaration, from memory.

Parameters

  sources | The memory chunk to interpret.

Returns
  The load result.

## ◆ processNodeTree()

ContentLoadResultNode nkGraphics::ContentLoader::processNodeTree | ( | nkExport::Node * | tree | ) |

Loads a node declaration, from an existing tree.

Parameters

  tree | The tree to interpret.

Returns
  The load result.

## ◆ loadBlendStateDeclaration()

ContentLoadResultBlendState nkGraphics::ContentLoader::loadBlendStateDeclaration | ( | nkMemory::StringView | pathFromData,
|  | bool | loadResource = `true`
| ) |  |

Loads a blend state declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processBlendStateSources()

ContentLoadResultBlendState nkGraphics::ContentLoader::processBlendStateSources | ( | nkMemory::StringView | sources,
|  | bool | loadResource = `true`
| ) |  |

Loads a blend state declaration, from memory.

Parameters

  sources | The memory chunk to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processBlendStateTree()

ContentLoadResultBlendState nkGraphics::ContentLoader::processBlendStateTree | ( | nkExport::Node * | tree,
|  | bool | loadResource = `true`
| ) |  |

Loads a blend state declaration, from an existing tree.

Parameters

  tree | The tree to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ loadDepthStencilStateDeclaration()

ContentLoadResultDepthStencilState nkGraphics::ContentLoader::loadDepthStencilStateDeclaration | ( | nkMemory::StringView | pathFromData,
|  | bool | loadResource = `true`
| ) |  |

Loads a depth and stencil state declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processDepthStencilStateSources()

ContentLoadResultDepthStencilState nkGraphics::ContentLoader::processDepthStencilStateSources | ( | nkMemory::StringView | sources,
|  | bool | loadResource = `true`
| ) |  |

Loads a depth and stencil state declaration, from memory.

Parameters

  sources | The memory chunk to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processDepthStencilStateTree()

ContentLoadResultDepthStencilState nkGraphics::ContentLoader::processDepthStencilStateTree | ( | nkExport::Node * | tree,
|  | bool | loadResource = `true`
| ) |  |

Loads a depth and stencil state declaration, from an existing tree.

Parameters

  tree | The tree to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ loadRasterStateDeclaration()

ContentLoadResultRasterState nkGraphics::ContentLoader::loadRasterStateDeclaration | ( | nkMemory::StringView | pathFromData,
|  | bool | loadResource = `true`
| ) |  |

Loads a raster state declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processRasterStateSources()

ContentLoadResultRasterState nkGraphics::ContentLoader::processRasterStateSources | ( | nkMemory::StringView | sources,
|  | bool | loadResource = `true`
| ) |  |

Loads a raster state declaration, from memory.

Parameters

  sources | The memory chunk to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ processRasterStateTree()

ContentLoadResultRasterState nkGraphics::ContentLoader::processRasterStateTree | ( | nkExport::Node * | tree,
|  | bool | loadResource = `true`
| ) |  |

Loads a raster state declaration, from an existing tree.

Parameters

  tree | The tree to interpret.
  loadResource | Whether the resource should be loaded in place (true) or not (false).

Returns
  The load result.

## ◆ loadCameraDeclaration()

ContentLoadResultCamera nkGraphics::ContentLoader::loadCameraDeclaration | ( | nkMemory::StringView | pathFromData | ) |

Loads a camera declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.

Returns
  The load result.

## ◆ processCameraSources()

ContentLoadResultCamera nkGraphics::ContentLoader::processCameraSources | ( | nkMemory::StringView | sources | ) |

Loads a camera declaration, from memory.

Parameters

  sources | The memory chunk to interpret.

Returns
  The load result.

## ◆ processCameraTree()

ContentLoadResultCamera nkGraphics::ContentLoader::processCameraTree | ( | nkExport::Node * | tree | ) |

Loads a camera declaration, from an existing tree.

Parameters

  tree | The tree to interpret.

Returns
  The load result.

## ◆ loadRenderQueueDeclaration()

ContentLoadResultRenderQueue nkGraphics::ContentLoader::loadRenderQueueDeclaration | ( | nkMemory::StringView | pathFromData | ) |

Loads a render queue declaration, from a file.

Parameters

  pathFromData | The file path, relative to working directory. See nkResources::ResourceManager for path naming convention.

Returns
  The load result.

## ◆ processRenderQueueSources()

ContentLoadResultRenderQueue nkGraphics::ContentLoader::processRenderQueueSources | ( | nkMemory::StringView | sources | ) |

Loads a render queue declaration, from memory.

Parameters

  sources | The memory chunk to interpret.

Returns
  The load result.

## ◆ processRenderQueueTree()

ContentLoadResultRenderQueue nkGraphics::ContentLoader::processRenderQueueTree | ( | nkExport::Node * | tree | ) |

Loads a render queue declaration, from an existing tree.

Parameters

  tree | The tree to interpret.

Returns
  The load result.

## ◆ appendCompositorNodeFromFile()

ContentLoadResultCompositorNode nkGraphics::ContentLoader::appendCompositorNodeFromFile | ( | nkMemory::StringView | pathFromData,
|  | Compositor * | parent
| ) |  |

Appends a node into a compositor, parsed from a file.

Parameters

  pathFromData | The path of the file to load, relative to the working directory. See nkResources::ResourceManager for path naming conventions.
  parent | The compositor to append the node to.

Returns
  The resulting node parsed.

Remarks
  The node returned will be already appended to the compositor.

## ◆ appendCompositorNodeFromSources()

ContentLoadResultCompositorNode nkGraphics::ContentLoader::appendCompositorNodeFromSources | ( | nkMemory::StringView | sources,
|  | Compositor * | parent
| ) |  |

Appends a node into a compositor, parsed from a source.

Parameters

  sources | The sources to parse.
  parent | The compositor to append the node to.

Returns
  The resulting node parsed.

Remarks
  The node returned will be already appended to the compositor.

## ◆ appendCompositorNodeFromTree()

ContentLoadResultCompositorNode nkGraphics::ContentLoader::appendCompositorNodeFromTree | ( | nkExport::Node * | tree,
|  | Compositor * | parent
| ) |  |

Appends a node into a compositor, parsed from a tree.

Parameters

  tree | The tree to get the compositor node from.
  parent | The compositor to append the node to.

Returns
  The resulting node parsed.

Remarks
  The node returned will be already appended to the compositor.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsGraphics/Exporter/ContentLoader.h